...12/9  ORe0 removed

Test:	PROC  ...enter with DE->data; ret. addr.->DEFT 'STR' to compare against
	...returns Z=1 if found, DE->next char., LASTDE=old DE
	POP HL
	LD C,(HL); INC HL  ...get count
	if @DE<>@HL then begin  ...test 1st char.
	  LD B,0; R.HL+R.BC; JP (HL)  ...test failed
	end
	LD B,C; LD (LASTDE),DE
	repeat
	  INC DE; INC HL
	  DJNZ $+3
	  JP (HL) ...sucessful test
	until @DE<>@HL;
	LD DE,(LASTDE) ...test failed, restore DE
	LD C,B; LD B,0  ...remaining count->R.BC
	R.HL+R.BC; JP (HL)

XLAT:	DEFM	'          :;<=>?' ... 0 - 9
	DEFM	'@               ' ... A - O
	DEFM	'           [\]^ ' ... P - Z and _
	DEFM	'`               ' ... a - o
	DEFM	'           {|}~'; BYTE 07F ... p - z
Id:	PROC  ...test for upper or lower case seq of letters & digits, starting
	...	 with upper case letter; i-o same as Test
	@DE='A'; RET C
	R.A->R.L; 'Z'=R.L; RET C
	LD (LASTDE),DE
	LD BC,XLAT-'0'
	repeat
	  INC DE; @DE='0'; JR C,RetZ
	  LD H,0; R.A->R.L  ...char.->HL
	until R.A=@(R.HL+R.BC);
	RET  ...Z=1

Digit:	PROC  ...test for a digit
	@DE='0'; RET C
	if R.A<>'9' then RET NC
STARIT:	LD (LASTDE),DE; INC DE
RetZ:	CP A; RET  ...set Z=1, R.A=char. tested

Hexd:	PROC  ...test for a hex digit; ret. in R.A
	Digit(); RET Z
	R.A='A'; RET C
	R.A='G'; JR C,STARIT
	R.A='a'; RET C
	R.A='g'; JR C,STARIT
	R.A|R.A; RET ...false

...	[ABC] => CALL Latch;DEFW ABC
...	Latch is a call allowing undefined symbols
Latch:	PROC
	POP BC ...^^ABC
	@BC->R.L; INC BC; @BC->R.H; INC BC ...^ABC->R.HL
	PUSH BC ...return address
Latch2:	if R.HL=0 not zero then JP (HL) ...if HL<>0, jump to routine
	DEC A; RET ...Z=0

...COPY routines: output to at DE with DE updated
Icopy:	PROC Outset()
Copy:	PROC  ...DEFT to copy follows call
	EX (SP),HL; PUSH BC
	LD C,(HL); INC HL  ...get count
	COPYSB()
	POP BC; EX (SP),HL
	RET
Copyin:	PROC  ...copies from LASTDE to NEXTDE
	W.LASTDE->R.HL
	B.NEXTDE-R.L->R.C
COPYSB:	LD B,0
	LDIR
	RET

STRING:	DEL()
	if @DE<>''' then begin R.A='"'; RET NZ end
	INC DE; R.A->R.C; JR SR2

Sr:	PROC  ...advance DE until @DE=quote, starting at DE+1
	LD C,'"'
SR2:	SRDO(LD B,80)  ...max count=80
	RET Z
TULONG:	Errm(); DEFT 'TOO LONG'

SRDO:	...enter with R.C=end str. char; R.B=max. count
	LD (LASTDE),DE; @DE->R.A
	repeat R.A=0D; JR Z,TULONG; INC DE; @DE=R.C; RET Z until DEC B zero;
	  ...note: above must be DJNZ
	RET

Sr1:	PROC ...testing for exactly one byte not "
	SRDO(LD C,'"'; LD B,1); RET Z
	DEC DE; RET

Count:	PROC ...inserts count byte into output
	B.LASTDE->R.B
	B.NEXTDE-R.B->@DE
	INC DE; RET

Inhex:	PROC  ...convert 2 hex digits @HL to value in R.A, inc. HL; uses R.C
	B.ASCtoN(@HL)*2*2*2*2->R.C  ...high nibble
	B.ASCtoN(@(R.HL+1))|R.C->R.A
	R.HL+1; RET

ASCtoN:	PROC  ...converts ascii char. 0-9,A-F in R.A to its value
	if R.A>='A' then R.A-7; R.A&0F; RET

HLout:	PROC  ...put out R.HL in hex at DE, incrementing DE
	PUSH AF; Outhex(R.H); Outhex(R.L); POP AF; RET

OUTHRL:	Icopy(); DEFT 'H'; R.L  ...puts into out area 'H' + R.L in hex
	...
Outhex:	PROC  ...R.A converted to hex & stored at DE & DE+1; DE=DE+2
	PUSH AF; RRA; RRA; RRA; RRA; HBTHEX(); POP AF
HBTHEX:	R.A&0F|R.A; DAA; R.A+0F0+carry+040->@DE; INC DE; RET

...TABLE ENTRY FORMAT OF SYMBOLS (byte pos. from beg. of entry):
LOC:	EQU	0 ...value of symbol
LINK:	EQU	2 ...link : 2 bytes
TYPE:	EQU	4
LNGTH:	EQU	5 ...length of symbol name
NAME:	EQU	6 ...start pos. of name
...bits of TYPE byte:
BYTET:	EQU	1 ...XXXX0001 if defined as BYTE
WORDT:	EQU	2 ...XXXX0010 if defined as WORD
PROCT:	EQU	3 ...XXXX0011 if PROCedure definition
DEFLT:	EQU	4 ...XXXX0100 if defined by DEFL
EQUT:	EQU	5 ...XXXX0101 if defined by EQU
UNDEFB:	EQU	3 ...XXXX1XXX if undefined
BANK2B:	EQU	4 ...XXX1XXXX if symbol in memory bank 2
ZAPB:	EQU	5 ...XX1XXXXX if symbol reusable
AL1B:	EQU	6 ...X1XXXXXX if undefined, indicates AL1 chain exists
			...   if defined, indicates no refs. to symbol exist
GLOBLB:	EQU	7 ...1XXXXXXX if global

Outset:	PROC ...set up for OUT functions
	LD (NEXTDE),DE
	LD DE,BUFF
	RET

Outp:	PROC  ...put out from ^BUFF to R.DE (+CR) to file if open, else to $CON
	0D->@DE; INC DE; PUTREC()
	JR OUTDUN  ...NEXTDE->DE; 1->Z
...
OUTHHL:	OUTHRL(); Outhex(R.H)  ...puts out "H"+R.L in hex + R.H in hex; cont:
	...
Out:	PROC ...C->CALL  L->LABEL  B->BINARY  "->STRING
	...A1->AL1  A2->AL2   H->HEX  V->1 byte  =->ASM
	...D->DEFINE LABEL = ((NCODE)-2)
	B.DIAGSW->R.A
	if BIT 3,A not zero then begin  ...check for /DIAG output
	  Putcon(); Put1(';')
	end
	' '->@DE  ...put space at end of stuff in buffer
	@^BUFF->R.A; INC HL  ...get first char
	if R.A='=' then begin  ...check for assembler type
	  LD BC,(NEXTDE); PUSH BC  ...save source ptr
	  '!'->@DE; INC DE  ...put '!' at end to stop parsing
	  LD BC,(FREE); PUSH BC  ...save stack top
	  SAVX()  ...save INSTLIST (@HL--DE) in user stack
	  POP DE  ...recall start of INSTLIST in stack
	  INSTLIST()  ...go parse statement
	  POP DE  ...recall NEXTDE
	  Ig()  ...pop text from stack
	  00; RET  ...1->Z
	end
	LD C,E; LD B,D
	LD DE,(NCODE)
	OUTCP()  ...go handle data in buffer (R.A=1st char., HL at 2nd)
	LD (NCODE),DE  ...new NCODE
OUTDUN:	LD DE,(NEXTDE)
	00; RET

OUTCP:	...checks 1st char. & then does the appropriate ops. on data in buffer
	if R.A='"' then begin DEC BC; JR CPQ end
	if R.A=''' then begin
CPQ:	  repeat WRaDEi(@HL) until R.HL+1=R.BC;
	  RET
	end
...CPC:
	if  R.A='C' then begin ...CHECK FOR CALL TYPE
	  WRaDEi(0CD)  ...put out CALL opcode
...	  LD	(NCODE),DE ...SO Lkup WILL WORK
	  JR	ISA2 ...GO INSERT ADDRESS
	end
	R.A='A'  ...symbol reference
	JP NZ,CPB
ISA2:	...ENTER HERE AFTER C TYPE, 2ND CHAR = ' '
	@HL='1' ...GET SECOND CHAR
	INC	HL
	JR	Z,ISA1
	if begin LD BC,(SAVNCD); R.B|R.C end not zero and @HL>='A' then begin
	  Lkupnl(); JR NZ,NDFERR; JR C,NDFERR
	    ...if imm. ex. or ORG, etc. then symbol (exc. tmp.) must be defined
	end else Lkup()  ...look up Id @HL; afterwards HL,IY->table entry
	endif
	if not zero then begin  ...if not found
	  WRaDEi(00); WRaDEi()  ...00->addr. to mark end of chain
	  SET UNDEFB,(IY+TYPE)  ...mark as undefined
	end else begin
	  WRaDEi(@HL)  ...copy low-order table entry->code area
	  WRaDEi(@(R.HL+1))  ...copy high-order table entry->code area
	  if not carry then begin  ...if found & defined
	    RES AL1B,(IY+TYPE); RET  ...indicate symbol has been referenced
	  end
	  BIT AL1B,(IY+TYPE); JR NZ,CPAMIX  ...check for mixed ref.
	  DEC HL
	end
	DEC DE; DEC DE
	LD (HL),E; INC HL; LD (HL),D  ...store addr. in symbol table
	INC DE; INC DE  ...DE=NCODE
	RET
CPAMIX:	CALL Errm; DEFT 'MIXED REF'

ISA1:	if Lkup() zero then begin  ...if found
	  LD C,(HL); INC HL; LD B,(HL)  ...(LOC)->BC
	  if carry then begin  ...if back ref.
	    BIT AL1B,(IY+TYPE); JR Z,CPAMIX  ...check for mixed ref.
	    LD (HL),D; DEC HL; LD (HL),E  ...DE (NCODE) ->(LOC)
	    W.OFFSET+R.BC  ...because DISP subtracts offset
	  end else begin  ...if defined
	    RES AL1B,(IY+TYPE)  ...ind. has been referenced
	    R.BC->R.HL  ...old (LOC)->R.HL
	  end
	  DISP()  ...disp. to be inserted ->R.A
	end
	else begin  ...if not found
	  SET UNDEFB,(IY+TYPE)  ...mark undef.
	  SET AL1B,(IY+TYPE)  ...set AL1
	  LD (HL),E; INC HL; LD (HL),D  ...DE (NCODE) ->(LOC)
	  00  ...0 to mark end of 1-byte chain
	end
	WRaDEi()  ...put out rel. disp. to addr. or prev. ref.
	RET
NDFERR:	CALL Errm; DEFT 'NOT DEFINED'

CPB:	if R.A='B' then begin  ...BINARY type
	  LD B,8  ...next 8 bytes are 0 or 1
	  RRC (HL); ADC A; INC HL; DJNZ $-4  ...R.A can start at anything
	  WRaDEi(); RET
	end
	if R.A='H' then begin ...HEXADECIMAL TYPE
CPHLUP:	  @HL=' '; RET Z
	  Inhex()  ...get 2 hex digits @HL converted to its value (->R.A)
	  WRaDEi()  ...put out byte
	  JR CPHLUP
	end	
	if R.A='O' then begin  ...OR type
	  LD B,0
	  ...OR following pairs of hex digits together:
	  while @HL<>' ' do B.Inhex()|R.B->R.B;
	  WRaDEi(R.B); RET
	end
	if R.A='V' then begin ...ONE BYTE ABSOLUTE
	  Lkupnl() ...call Lkup without linking in
	  JR	C,NDFERR
	  JR	NZ,NDFERR
	  WRaDEi(@HL)  ...put out low-order byte
	  RES AL1B,(IY+TYPE)  ...indicate symbol has been referenced
	  RET
	end
	if R.A='D' then begin  ...check for DEFINE type
	  DEC DE; DEC DE; PUSH DE  ...save for NCODE
	  EX DE,HL; RDa2HL(); EX DE,HL; LD E,C; LD D,B  ...@2DE->DE(def. value)
	  JR CPDL1
	end
	R.A='L'; RET NZ ...do nothing if 1st char. anything else
	...LABEL
	PUSH DE  ...save for NCODE
	PUSH HL; W.OFFSET+R.DE; EX DE,HL; POP HL  ...add offset
CPDL1:	if Lkup() not carry then begin  ...call Lkup, chk if no back ref.
	  CALL Z,RDFERR  ...if already defined, chk if can redefine
	  RES AL1B,(IY+TYPE)  ...indicate no AL1 chain
	  00->@HL->@(R.HL+1); DEC HL  ...00->(LOC)
	end
	CPDL2()  ...put value in symbol table, resolve chain
	POP DE; RET

CPDL2:	...store DE in symbol table, resolve chain
	RES UNDEFB,(IY+TYPE)  ...set defined
	LD C,(HL); INC HL; LD B,(HL)  ...(LOC)->BC
	LD (HL),D; DEC HL; LD (HL),E  ...DE->(LOC)
	BIT AL1B,(IY+TYPE); PUSH AF
	if R.B|R.C zero then SET AL1B,(IY+TYPE)  ...if no back ref.
	else RES AL1B,(IY+TYPE)  ...indicate symbol has been referenced
	POP AF; JR NZ,AL1  ...go resolve 1-byte chain
	...store R.DE (NCODE or def. value) into places referenced by chain:
CPLLUP:	R.BC->R.HL=0; RET Z  ...next loc. in chain->R.HL, end of chain if 0
	RDa2HL(); WRa2HL(); JR CPLLUP  ...@2HL->BC; DE->@2HL

RDFERR:	B.QOPTS; BIT 0,A; RET NZ  ...if BIT 0,QOPTS=1 then ok to redefine label
	LD BC,BUFF; if @BC='D' then begin B.GETTYP()=DEFLT; RET Z end
	  ...ok to redefine DEFL with "D" type
	CALL Errm; DEFT 'REDEFINED LABEL'

AL1:	...1-byte chain will now be resolved
	R.BC->R.HL  ...addr. of last ref. (from table) -> HL
AL1LUP:	PUSH DE  ...value of label (NCODE)
	EX DE,HL; DISP(); EX DE,HL
	  ...get diff. $-addr-1 in R.A, checking for out-of-range
	POP DE  ...$
	RDa2HL()  ...contents of current addr. in chain ->R.C
	WRaHL()  ...store at addr. the calculated rel. displacement
	R.C=0; RET Z  ...check for 0 => end of chain
	BIT 7,C; JR Z,OORERR  ...error if chain pts. forward
	LD B,-1
	R.HL+R.BC+1  ...next chain location ->R.HL
	JR AL1LUP

DISP:	...calcs. HL-OFFSET-DE-1, checking for out-of-range, & stores in R.A
	...DE not changed
	LD BC,(OFFSET); R.HL-R.BC
	SCF; R.HL-carry-R.DE
	R.L->R.A
	if INC H zero then begin BIT 7,L; RET NZ end
	if DEC H zero then begin BIT 7,L; RET Z end
OORERR:	CALL Errm; DEFT 'OUT OF RANGE'

Lkupnl:	PROC
	1->B.LINKSW  ...don't add to symbol table if not found; FALL THRU:

...Lkup	EXPECTS HL POINTING TO DATA ENDING WITH A ' '
...	RETURNS HL,IY POINTING TO TABLE ENTRY
...	Z=1 if found, CARRY=1 if referenced & not defined
...	DE unchanged
Lkup:	PROC
	PUSH DE
	LD D,H; LD E,L  ...HL->DE
	LD A,' '
	LD BC,080  ...limit to search
	CPIR
	DEC HL; EX DE,HL  ...DE points to ' '
	NLKUP()
	POP DE; RET

LINKER:	...expects : HL at base link; IY at new entry
	...performs: if (HL)=0, 0->(IY+LINK); else (HL)-[IY+LINK-HL]->(IY+LINK)
	...	     [IY+LINK-HL]->(HL)
	...returns : IY unchanged
	LD C,(HL); INC HL; LD B,(HL); DEC HL  ...@2HL->R.BC
	PUSH HL; LD DE,LINK; R.IY+R.DE; POP DE  ...HL=IY+LINK, DE=orig. HL
	R.HL-R.DE; EX DE,HL  ...DE=IY+LINK-HL, HL=orig. HL
	LD (HL),E; INC HL; LD (HL),D  ...DE->@2HL
	if R.B|R.C not zero then R.BC-carry-R.DE->R.BC  ...BC=(HL)-[IY+LINK-HL]
	LD (IY+LINK),C; LD (IY+LINK+1),B  ...BC->(IY+LINK)
	RET

HASHER:	PROC ...generates hash code for lookup table
	...expects R.A with symbol length; symbol @HL
	...returns code*2+2 in R.DE, init. link in HL
	DEC A; @HL->R.A
	if not zero then R.A*2*2.XOR.@(R.HL+1)
	AND NHASH-1
	R.A+1*2->R.E; LD D,0; W.TABBSE+R.DE->R.HL; RET

NLKUP:	...expects: HL pointing to first source character
	...	    DE pointing after last source character
	...returns: HL,IY pointing to table entry
	...	    DE pointing after source symbol
	...	    Z=1 if found, CARRY=1 if referenced & not defined
	PUSH	DE
	PUSH	HL
	R.E-R.L->R.A->R.B  ...length of symbol
	LD C,(HL)  ...1st char.
	HASHER()  ...get HL=^init. link
	LD DE,0-LINK
	R.HL+R.DE->R.IY  ...pt. to appropriate base link-LINK
	JR LKLUP
LKLUP0:	POP BC
LKLUP:	repeat LD E,(IY+LINK); LD D,(IY+LINK+1)
	  R.D|R.E; JR Z,LKEND  ...end chain
	  ADD IY,DE
	until R.C=@IY(NAME);
	R.B=@IY(LNGTH); JR NZ,LKLUP
	LD DE,NAME+1; R.IY+R.DE->R.HL  ...pt. HL to name+1
	POP DE; PUSH DE  ...source starting char.
	PUSH BC
	if DEC B not zero then begin
	  repeat INC DE
	    @DE=@HL; JR NZ,LKLUP0
	    INC HL
	  until DEC B zero;
	end
	if BIT BANK2B,(IY+TYPE) not zero then INC B  ...B=0 or 1
	B.CODEBK=R.B; JR NZ,LKLUP0  ...bank symbol in must match CODEBK
	POP BC
	POP	DE ...source starting character
	BIT	ZAPB,(IY+TYPE) ...check if zapped
	JR	NZ,LKFIN
	R.A|R.A ...reset the CARRY
	BIT	UNDEFB,(IY+TYPE) ...SETS Z=1 IF SYMBOL DEFINED
	JR	Z,LKEXIT ...OK, Z=1,C=0
	00->R.A ...Z<-1,C<-0
	CCF	...Z=1,C<-1 PREV REF
	JR	LKEXIT
LKEND:	POP	DE ...start of source symbol
	B.LINKSW|R.A; JR NZ,LKEXIT  ...if don't want linked up (Z=0, C=0)
	PUSH	DE ...start source symbol
	W.TABBSE; LD E,(HL); INC HL; LD D,(HL); DEC HL  ...DE=@2W.TABBSE
	R.HL+R.DE->R.IY  ...next free loc. (ENDSYM) ->R.HL->IY
	LD C,B; LD B,0  ...length
	LD DE,NAME; R.HL+R.DE+R.BC->R.HL ...HL gets new end of symbol table
	LD DE,(ENDTAB) ...end of symbol table
	SCF; R.HL-carry-R.DE ...test if room left in symbol table for new entry
	JR	NC,TUMANY ...too many symbols
	LD	(IY+LNGTH),C ...length of symbol name
	^NAME->R.HL
	PUSH	IY
	POP	DE ...table entry
	R.HL+R.DE->R.HL  ...name in table entry
	POP	DE ...start of source symbol
	EX	DE,HL; PUSH DE  ...save ^name in tbl entry
	LDIR  ...symbol name in table (DE->new end of symbols)
	TABLEN()  ...store rel. len. of table at TABBSE
	POP HL; @IY(LNGTH)->R.A  ...^name->HL
	HASHER()  ...base link->HL
	LINKER()  ...link up (IY at new table entry)
LKFIN:	B.LINKSW=0; JR NZ,LKEXIT  ...Z=0, C=0
	R.IY->R.HL  ...table entry
	R.A->@HL->@(R.HL+1)  ...00->(LOC)
	if B.CODEBK<>0 then LD A,2**BANK2B
	R.A->@IY(TYPE)  ...clear type byte except BANK2B bit set if bank 2
	R.A|1  ...set Z=0,C=0
LKEXIT:
	0->B.LINKSW
	R.IY->R.HL
	POP DE  ...after source symbol
	RET
TUMANY:	CALL Errm; DEFT 'TOO MANY SYMBOLS'

TSTEND:	...performs R.HL::(W.TABBSE+@2W.TABBSE); preserves HL,DE,IY,A
	...returns BC->end of symbols (ENDSYM)
	PUSH HL; W.TABBSE; LD C,(HL); INC HL; LD B,(HL); DEC HL
	R.HL+R.BC->R.BC; POP HL; R.HL=R.BC; RET

TABINT:	...set 1st 2 bytes @HL = rel. disp. to init. table end position
	...0's -> init. links (@(R.HL+2...)); ret. HL at pos. for 1st entry
	W.TABBSE; LD B,2*NHASH+2
	LD (HL),B; DEC B
TBINT2:	INC HL; 00; repeat R.A->@HL; INC HL until DEC B zero;
	RET

TABLEN:	...enter with DE at end of symbols; store rel. len. of table @2TABBSE
	W.TABBSE; EX DE,HL; R.HL-R.DE; EX DE,HL
	LD (HL),E; INC HL; LD (HL),D; RET

PACK:	PROC ...pack symbol table
	PUSH DE
	LD B,2*NHASH; TBINT2(W.TABBSE+1)  ...zero init. links
	R.HL->R.IY; EX DE,HL  ...IY,DE->1st entry
	JR PK2
PKLUP:	ADD IY,BC
PK2:	while TSTEND(R.IY) <zero do begin  ...IY pts. to next entry orig. tbl
	  @IY(LNGTH)+NAME->R.C; LD B,0  ...len. of entry->BC
	  if BIT UNDEFB,(IY+TYPE) zero then begin  ...save undef'd symbols
	    Tstsym(); JR NZ,PKLUP  ...skip if masked out
	    if B.PAKSW=0 then begin  ...chk if packing just globals
	      BIT GLOBLB,(IY+TYPE); JR Z,PKLUP  ...skip if not global
	    end
	  end
	  BIT ZAPB,(IY+TYPE); JR NZ,PKLUP  ...skip if zapped
	  PUSH DE; POP IY  ...^old entry->HL; ^new entry->IY
	  LDIR  ...move old entry to new table
	  PUSH DE; PUSH HL  ...save DE,HL
	  @IY(LNGTH)->R.A
	  LD DE,NAME; R.IY+R.DE  ...HL pts. to symbol name
	  HASHER()  ...base of table + HASH = 1st link -> HL
	  LINKER()  ...link @HL->here; here->prev. link @HL (IY=^new entry)
	  POP IY; POP DE  ...IY=^next entry orig. tbl; DE=^next new entry
	end
	TABLEN()  ...store len. of new table at TABBSE
	POP DE; 00; RET

Nxtsym:	PROC ...steps through symbol table by hash codes and links
	...if R.A=0 then returns first symbol first chain, else returns next
	...	symbol same chain (then next chain)
	...returns Z=1, HL,IY at symbol tbl entry if found; Z=0 if at end
	PUSH BC
	if R.A=0 then begin R.A->Hash; W.TABBSE+2 end
	else W.Link
	while begin  ...get ptr. to link of next entry (R.HL+@2HL->Link):
	  LD C,(HL); INC HL; LD B,(HL); DEC HL
	  R.HL+R.BC->W.Link; R.B|R.C  ...Z=1 iff end of chain (@2HL=0)
	end zero and B.Hash<NHASH do begin
	  R.A+1->B.Hash; R.A+1*2->R.C; LD B,0  ...R.A+1*2=2+(R.A*2)
	  W.TABBSE+R.BC->R.HL  ...ptr. to next base link
	end
	LD BC,0-LINK; R.HL+R.BC->R.HL
	B.Hash::NHASH  ...done if Hash>=NHASH
	if <zero then begin R.HL->R.IY; CP A end else OR A  ...set Z flag
	POP BC; RET

Tstsym:	PROC  ...tests symbol @HL to see if not masked out
	...chk MAPCMP, MAPMSK, MAPBEG & MAPEND
	PUSH DE; PUSH BC; PUSH HL
	LD E,(HL); INC HL; LD D,(HL)  ...DE=(LOC)
	LD BC,TYPE-1; R.HL+R.BC  ...HL pts. to TYPE
	B.MAPMSK->R.B
	if B.MAPCMP.XOR.@HL&R.B zero then begin
	  if W.MAPEND-R.DE>=zero and W.MAPBEG-carry-R.DE<zero then CP A
	end
	POP HL; POP BC; POP DE; RET

NXTsym:	PROC  ...get next symbol not masked out (HL,IY pt. to)
	repeat Nxtsym(); RET NZ until begin Tstsym(); 1 end; RET

Nm00:	DEFB 0  ...min. symbol alphabetically
NmFF:	DEFB 0FF  ...max. symbol

Map:	PROC ...prints out symbols and values
	PUSH DE; ^BUFF->Nxtpos
	if B.MAPTYP<>'A' then begin  ...do by order of occurrence:
	  W.TABBSE; LD BC,NHASH*2+2
	  while TSTEND(R.HL+R.BC) <zero do begin  ...HL pts. to entry
	    PUSH HL
	    Tstsym(); CALL Z,PutOut  ...put out if not masked out
	    POP HL
	    LD BC,LNGTH; R.HL+R.BC; LD C,(HL); INC C  ...HL at LNGTH;BC=LNGTH+1
	  end
	end else begin  ...do alphabetically:
	  ^Nm00->LastNm
	  while GetLNm() zero do PutOut()
	end
	LD DE,(Nxtpos); ^BUFF; PUSH HL
	R.HL-R.DE; CALL NZ,Outmsg  ...if not 1st col., put out last line
	POP DE; P.Copy; DEFT 'Rem Space='
	TSTEND(); W.ENDTAB-R.BC  ...calc. remaining space (BC=end of symbols)
	HLout(R.HL); Outmsg()  ...print Rem Space=hhhh
	POP DE; RET

GetLNm:	...get least name>LastNm pointed to by HL (@LOC) & LastNm (@NAME)
	LD BC,NmFF; 00->R.A  ...current least name stored in BC
	while NXTsym() zero do begin
	  LD DE,NAME; R.HL+R.DE  ...HL pts. @NAME of next entry
	  LD DE,(LastNm)  ...last symbol put out
	  if CPName() <zero then begin  ...chk if entry>LastNm
	    LD D,B; LD E,C  ...current least name
	    if CPName() >=zero then R.HL->R.BC  ...new least name
	  end
	  LD A,1  ...for NXTsym
	end
	LD (LastNm),BC
	if ^NmFF-R.BC zero then INC L else CP A  ...set Z flag
	LD HL,-NAME; R.HL+R.BC->R.HL
	RET

CPName:	PROC ...compare name pointed to by DE to name pointed to by HL
	...enter HL,DE at NAME in symbol tbl (LNGTH before); preserve HL,BC,DE
	@DE=@HL; RET NZ  ...cmp. 1st char.
	PUSH BC; PUSH DE; PUSH HL
	DEC HL; DEC DE
	if @DE>=@HL then @HL; LD B,A  ...min. len.->R.B
	PUSH AF
	repeat INC HL; INC DE
	  @DE=@HL; JR NZ,CPNX  ...cmp. chars. in name
	until DEC B zero;
	POP AF; JR NZ,CPNX2  ...chk length comparison
	POP HL; POP DE
	PUSH DE; PUSH HL
	LD BC,TYPE-NAME
	EX DE,HL; R.HL+R.BC; EX DE,HL  ...DE pts. to TYPE byte
	R.HL+R.BC  ...ditto HL
	@DE=@HL  ...if names equal, cmp. type byte
	JR CPNX2
CPNX:	POP HL
CPNX2:	POP HL; POP DE; POP BC; RET

PutOut:	...put out Map entries, starting cols. 0,20,40,60
	...enter with HL pointing to symbol tbl entry
	PUSH HL
	LD E,(HL); INC HL; LD D,(HL)
	W.Nxtpos; EX DE,HL
	HLout(); OutSP()  ...put out value (+space)
	POP HL; LD BC,TYPE; R.HL+R.BC
	OuthxB(@HL)  ...put out type
	LD BC,LNGTH-TYPE; R.HL+R.BC
	LD C,(HL); LD B,0; INC HL  ...R.C=len.
	LDIR  ...put out name
	LD HL,BUFF-1; LD BC,20
	repeat R.HL+R.BC until R.HL-carry-R.DE+R.DE>=zero; ...note: carry reset
	repeat OutSP() until R.HL-carry-R.DE+R.DE<zero; ...note carry set
	LD HL,BUFF+80
	if R.HL-carry-R.DE<zero then begin DEC DE; Outmsg(); LD DE,BUFF end
	LD (Nxtpos),DE; RET

OuthxB:	Outhex()
OutSP:	' '->@DE; INC DE; RET

Gen:	PROC ...GENERATES NEW SYMBOL OF FORM 'NN'#
	...	CHECKING IF PREVIOUSLY CALLED AT THIS LEVEL
	POP	HL
	POP	BC ...POP PRIOR RETURN ADDRESS
	PUSH	HL ...SAVE RETURN
	^GENCLN-R.BC
	POP	HL
	JR	Z,GEN2ND
	PUSH	BC
	PUSH	HL
	^TMPTAB; LD B,16  ...16 poss. temp. symbol values
	repeat  ...chk table marking temp. symbols as used or not
	  @HL=0; JR Z,GENOK  ...0 means not used
	  INC HL
	until DEC B zero;
TUDEEP:	CALL	Errm
	DEFT	'TOO DEEP'  ...nested too deep
GENOK:	16-R.B->R.A  ...value of temp. symbol
	LD (HL),3  ...mark symbol used in TMPTAB
	POP	HL ...return address
	PUSH	AF
	LD	BC,GENCLN
GEN2ND:	POP	AF ...R.A=temp. symbol value
	PUSH	AF
	PUSH	BC ...BC=GENCLN
	CALL	Outhex
	'#'->@DE; INC DE
	JP	(HL)
GENCLN:	POP BC; LD C,B; LD B,0  ...clean up stack; temp. symbol value->BC
	^TMPTAB+R.BC; RES 1,(HL)  ...note: Zp resets bit 0
	RET  ...note: GENCLN must preserve Z-flag

Zp:	PROC
	SET ZAPB,(IY+TYPE)  ...mark zapped in symbol table
	LD A,(IY+NAME+1)  ...low-order no. in name (high-order is 0)
	ASCtoN()  ...convert R.A to its value
...Note: this routine will have to change to include high-order no. in name if
...	 no. of temporary symbols increased to more than 16
	LD C,A; 00->R.B  ...symbol value->BC; 1->Z
	^TMPTAB+R.BC  ...pt. into table marking temp. symbols as used or not
	RES 0,(HL)  ...note: GENCLN (in Gen) resets bits 1
	RET

SAVN:	OUTHRL()  ...save a one-byte number in R.L on stack; conts. below:

Sav:	PROC	...puts bytes from ^BUFF to DE, then count, in STACK starting
		...at W.FREE; W.FREE updated; DE pointed again to source
	SAVX(^BUFF)
	JP OUTDUN  ...NEXTDE->DE; 1->Z; RET

SAVX:	...saves from HL to DE on STACK
	R.E-R.L->R.C; LD B,0  ...length->R.BC
	LD DE,(FREE)  ...get dest.
	if not zero then LDIR  ...copy bytes unless BC=0
	R.A->@DE; INC DE  ...save count
	LD (FREE),DE
	RET

Re:	PROC ...restore last item on stack to @DE+..
	Ig()
R1:	R.A=R.C; RET Z
	LDIR; RET

Pp:	PROC ...effectively pops to @DE+.. & pushes again (leaves on stack)
	RPI(); JR R1

Ig:	PROC ...pop last item from stack without putting anywhere
	...	ret. BC=len.; Z=0
	RPI()
	R.HL->W.FREE  ...adjust stack pointer
	RET

RPI:	...ret. HL=^prev. string, BC=length, R.A=0 (for R1), Z=0 (for Ig)
	W.FREE-1
	LD C,(HL)
	00->R.B
	SBC HL,BC  ...HL->first char.; set Z=0 for Ig
	RET

Xc:	PROC ...swap top two, DE unchanged
	PUSH DE; PUSH DE
	Re()  ...1st string out
	PUSH DE  ...^ end 1st
	Re()  ...2nd string out
	POP BC  ...end 1st
	POP HL  ...beg. 1st
	PUSH DE  ...end 2nd
	PUSH BC  ...end 1st; beg. 2nd
	LD D,B; LD E,C
	SAVX()  ...save 1st
	POP HL  ...beg. 2nd (this pop & prev. push unneeded with present SAVX)
	POP DE  ...end 2nd
	SAVX()  ...save 2nd
	POP DE; RET

	...the following do a recall & shift (left) in preparation for orring:
ORe4:	PROC; LD B,4; JR ORe  ...n=no. places to shift=4
ORe3:	PROC; LD B,3  ...n=3
ORe:	PUSH BC
	Re(); DEC DE; DEC DE
	B.Inhex(R.DE)->R.A  ...get hex # from @DE
	POP BC
	repeat R.A*2 until DEC B zero;  ...R.A*(2^n)->R.A
	Outhex(R.A); RET

Eff1:	PROC ...deletes code of form 2000H
	@(W.NCODE-1)=0; RET NZ
	@(R.HL-1)=020; RET NZ
	R.HL->W.NCODE; RET

*ZAP	DATE FREE Link Hash LastNm Nxtpos TMPTAB ENDTAB PUTREC  ...in MMETA
*ZAP	XLAT STARIT RetZ COPYSB SR2 TULONG SRDO HBTHEX LDI_N2 OUTDUN OUTCP CPQ
*ZAP	ISA2 CPAMIX ISA1 DISP CPB RDFERR CPDL1 CPDL2 CPLLUP AL1 AL1LUP
*ZAP	CPHLUP LINKER HASHER LKLUP0 LKLUP LKEND LKFIN LKEXIT TUMANY TSTEND
*ZAP	TBINT2 TABLEN PKLUP PK2 Tstsym
*ZAP	Nm00 NmFF GetLNm CPName CPNX CPNX2 PutOut
*ZAP	TUDEEP GENOK GEN2ND GENCLN SAVX R1 RPI ORe
*PACK ALL
AB PUTREC  ...in MMETA
*ZAP	XLAT